module uart_tx(
	clk,
	rst_n,
	tx_trigger,
	tx_data,
	tx);

	//---Ports declearation: generated by Robei---
	input clk;
	input rst_n;
	input tx_trigger;
	input [7:0] tx_data;
	output tx;

	wire clk;
	wire rst_n;
	wire tx_trigger;
	wire [7:0] tx_data;
	reg tx;

	//----Code starts here: integrated by Robei-----
	localparam      CNT_0   = 5;
			localparam      CNT_1   = 3;
	
			reg [12:0]  cnt0;
			wire    add_cnt0;
			wire    end_cnt0;
			
			reg [3:0]   cnt1;
			wire        add_cnt1;
			wire        end_cnt1;
			
			reg         flag_tx;
			reg [7:0]   tx_data_reg;
	
			always @(posedge clk or negedge rst_n)begin
			    if(!rst_n)begin
			        cnt0 <= 0;
			    end
			    else if(add_cnt0)begin
			        if(end_cnt0)
			            cnt0 <= 0;
			        else
			            cnt0 <= cnt0 + 1;
			    end
			end
			
			assign add_cnt0 =flag_tx ;
			assign end_cnt0 = add_cnt0 && cnt0==CNT_0-1 ;
			
	
			always @(posedge clk or negedge rst_n)begin 
			    if(!rst_n)begin
			        cnt1 <= 0;
			    end
			    else if(add_cnt1)begin
			        if(end_cnt1)
			            cnt1 <= 0;
			        else
			            cnt1 <= cnt1 + 1;
			    end
			end
			
			assign add_cnt1 = end_cnt0;
			assign end_cnt1 = add_cnt1 && cnt1==CNT_1-1 ;
			
	
			always  @(posedge clk or negedge rst_n)begin
			    if(rst_n==1'b0)begin
			        tx_data_reg <= 0;
			    end
			    else if(tx_trigger == 1'b1 && flag_tx == 1'b0)begin
			        tx_data_reg <= tx_data;
			    end
			end
			
	
			always  @(posedge clk or negedge rst_n)begin
			    if(rst_n==1'b0)begin
			        flag_tx <= 0;
			    end
			    else if(tx_trigger == 1 &&flag_tx == 0)begin
			        flag_tx <= 1;
			    end
			    else if(end_cnt1) begin
			        flag_tx <= 0;
			    end
			end
			
	
			always  @(posedge clk or negedge rst_n)begin
			    if(rst_n==1'b0)begin
			        tx <= 1;
			    end
			    else if(flag_tx == 1)begin
			        case(cnt1)
			            0:      tx <= 0;
			            1:      tx <= tx_data_reg[0];
			            2:      tx <= tx_data_reg[1];
			            3:      tx <= tx_data_reg[2];
			            4:      tx <= tx_data_reg[3];
			            5:      tx <= tx_data_reg[4];
			            6:      tx <= tx_data_reg[5];
			            7:      tx <= tx_data_reg[6];
			            8:      tx <= tx_data_reg[7];
			            default:tx <= 1;
			        endcase
			    end
			    else
			    tx <= 1;
			end
	
	
endmodule    //uart_tx

