module Kalman(
	rst_n,
	clk,
	data_in,
	data_out);

	//---Ports declearation: generated by Robei---
	input rst_n;
	input clk;
	input [31:0] data_in;
	output [31:0] data_out;

	wire rst_n;
	wire clk;
	wire [31:0] data_in;
	reg [31:0] data_out;

	//----Code starts here: integrated by Robei-----
	parameter	Q	= 32'd655;		
	parameter	R	= 32'd65536;
	
	reg	[31:0]	P		= 32'd0;
	reg	[31:0]	LastP	= 32'd0;
	reg	[15:0]	Kg		= 16'd0;
	reg	[31:0]	LastOut	= 32'd0;
	
	always @(posedge clk or negedge rst_n) begin
		if(~rst_n)begin
			P		= 32'd0;
			LastP	= 32'd0;
			Kg		= 16'd0;
			LastOut	= 32'd0;
		end
		else begin
			P			= LastP + Q;	
			Kg			= (P<<16) / (P + R);
			data_out	= (data_in>LastOut)?
						   LastOut + ((Kg * (data_in - LastOut))>>16):
						   LastOut - ((Kg * (LastOut - data_in))>>16);
			LastP		= ((16'd65535 - Kg) * P)>>16;
			LastOut		= data_out;
		end
	end
	
	
	
endmodule    //Kalman

