module OLED_T_H_Top(
	sys_clk,
	rst_n,
	dht11_done,
	tempH,
	tempL,
	humidityH,
	humidityL,
	OLED_SCL,
	OLED_SDA,
	init_req,
	init_finish,
	refresh_req,
	refresh_finish,
	showfont_req,
	showfont_finish,
	showdata_req,
	showdata_finish,
	IICWriteData,
	IICWriteReq,
	IICWriteData_8,
	data_in,
	data_out);

	//---Ports declearation: generated by Robei---
	input sys_clk;
	input rst_n;
	input dht11_done;
	input [7:0] tempH;
	input [7:0] tempL;
	input [7:0] humidityH;
	input [7:0] humidityL;
	output OLED_SCL;
	inout OLED_SDA;
	input init_req;
	output init_finish;
	input refresh_req;
	output refresh_finish;
	input showfont_req;
	output showfont_finish;
	input showdata_req;
	output showdata_finish;
	input [15:0] IICWriteData;
	input IICWriteReq;
	input [7:0] IICWriteData_8;
	input [31:0] data_in;
	output [31:0] data_out;

	wire sys_clk;
	wire rst_n;
	wire dht11_done;
	wire [7:0] tempH;
	wire [7:0] tempL;
	wire [7:0] humidityH;
	wire [7:0] humidityL;
	wire OLED_SCL;
	wire OLED_SDA;
	wire init_req;
	wire init_finish;
	wire refresh_req;
	wire refresh_finish;
	wire showfont_req;
	wire showfont_finish;
	wire showdata_req;
	wire showdata_finish;
	wire [15:0] IICWriteData;
	wire IICWriteReq;
	wire [7:0] IICWriteData_8;
	wire [31:0] data_in;
	wire [31:0] data_out;
	wire [23:0] OLED_Init1_Init_data;
	wire [23:0] OLED_Refresh2_refresh_data;
	wire [23:0] OLED_ShowFont3_ShowFont_Data;
	wire [23:0] OLED_ShowData4_ShowData_Data;
	wire IIC_Driver6_IICWriteDone;

	//----Code starts here: integrated by Robei-----
	localparam	OLED_INIT 		=  'd0;			
	localparam	OLED_Refresh	=  'd1;			
	localparam  OLED_ShowFont	=	'd2;		
	localparam	OLED_IDLE 		=  'd3;			
	localparam	OLED_ShowData	=	'd4;		
	
	
	
	
	reg[4:0]	state , next_state;
	
	
	
	assign init_req     = (state == OLED_INIT)     ? 1'b1 : 1'b0;
	
	assign refresh_req  = (state == OLED_Refresh)  ? 1'b1 : 1'b0;
	
	assign showfont_req = (state == OLED_ShowFont) ? 1'b1 : 1'b0;
	
	assign showdata_req = (state == OLED_ShowData) ? 1'b1 : 1'b0;
	
	always@(posedge sys_clk or negedge rst_n)
	begin
		if(rst_n == 1'b0)
			state <= OLED_INIT;
		else
			state <= next_state;
	end
	
	always@(*)
	begin
		case(state)
		OLED_INIT:
			if(init_finish == 1'b1)
				next_state <= OLED_Refresh;
			else
				next_state <= OLED_INIT;
		OLED_Refresh:
			if(refresh_finish == 1'b1)
				next_state <= OLED_ShowFont;
			else
				next_state <= OLED_Refresh;
		OLED_ShowFont:
			if(showfont_finish == 1'b1)
				next_state <= OLED_IDLE;
			else
				next_state <= OLED_ShowFont;
		OLED_IDLE:
			if(dht11_done == 1'b1)
				next_state <= OLED_ShowData;
			else
				next_state <= OLED_IDLE;
		OLED_ShowData:
			if(showdata_finish == 1'b1)
				next_state <= OLED_IDLE;
			else
				next_state <= OLED_ShowData;
		default: next_state <= OLED_INIT;
		endcase
	end
	
	
	
	
	
	OLED_Init OLED_InitHP(
		
		.sys_clk				(sys_clk),
		.rst_n				(rst_n),
		
		.init_req			(init_req),		
		.write_done			(IICWriteDone),	
		
		.init_finish		(init_finish),	
	
		.Init_data			(Init_data)
	);
	
	
	OLED_Refresh tt(
		.sys_clk				(sys_clk),
		.rst_n				(rst_n),
		
		.refresh_req		(refresh_req),	
		.write_done			(IICWriteDone),	
		
		.refresh_finish	(refresh_finish),	
	
		.refresh_data		(refresh_data)	
	);
	
	
	OLED_ShowFont OLED_ShowFont_HP(
	
		.sys_clk			(sys_clk),
		.rst_n			(rst_n),
		
		.ShowFont_req	(showfont_req),		 
		.write_done		(IICWriteDone),		
		
		.ShowFont_Data		(showfont_data),
		
		.ShowFont_finish(showfont_finish)    
	);
	
	OLED_ShowData OLED_ShowDataHP(
		
		.sys_clk			(sys_clk),
		.rst_n			(rst_n),
		
		.dht11_done		(dht11_done),
		.tempH			(tempH),			
		.tempL			(tempL),			
		.humidityH		(humidityH),		
		.humidityL		(humidityL),		
		
		
		.ShowData_req	(showdata_req),		
		.write_done		(IICWriteDone),		
		
		.ShowData_Data	(showdata_data),	
		
		.ShowData_finish	(showdata_finish)
	
	);
	
	
	//数据选择
	OLED_SelData OLED_SelDataHP(
		
		.sys_clk			(sys_clk),
		.rst_n			(rst_n),
		
		
		.init_req		(init_req),
		.init_data		(Init_data),
		
		.refresh_req	(refresh_req),
		.refresh_data	(refresh_data),
			
		.showfont_req	(showfont_req),
		.showfont_data	(showfont_data),
		
		.showdata_req	(showdata_req),
		.showdata_data	(showdata_data),
		
		
		.IICWriteReq	(IICWriteReq),	
		.IICWriteData	(IICWriteData)
	);
	
	
	
	IIC_Driver IIC_DriverHP_OLED(
	   .sys_clk				(sys_clk),       
	   .rst_n				(rst_n),           
	
	    .IICSCL				(OLED_SCL),          
	    .IICSDA				(OLED_SDA),          
	
	
	    .IICSlave			({IICWriteData[15:8],IICWriteData[23:16]}),           
	    .IICWriteReq		(IICWriteReq),     
	    .IICWriteDone		(IICWriteDone),    
	    .IICWriteData		(IICWriteData[7:0]),      
	
	    .IICReadReq			(1'b0),       
	    .IICReadDone			(),    
	    .IICReadData    		()  
	);
	
	
	
	
	
	//---Module instantiation---
	OLED_Init OLED_Init1(
		.sys_clk(sys_clk),
		.rst_n(rst_n),
		.init_req(init_req),
		.write_done(IIC_Driver6_IICWriteDone),
		.init_finish(init_finish),
		.Init_data(OLED_Init1_Init_data));

	OLED_Refresh OLED_Refresh2(
		.sys_clk(sys_clk),
		.rst_n(rst_n),
		.refresh_req(refresh_req),
		.write_done(IIC_Driver6_IICWriteDone),
		.refresh_finish(refresh_finish),
		.refresh_data(OLED_Refresh2_refresh_data));

	OLED_ShowFont OLED_ShowFont3(
		.sys_clk(sys_clk),
		.rst_n(rst_n),
		.ShowFont_req(showfont_req),
		.write_done(IIC_Driver6_IICWriteDone),
		.ShowFont_Data(OLED_ShowFont3_ShowFont_Data),
		.ShowFont_finish(showfont_finish));

	OLED_ShowData OLED_ShowData4(
		.sys_clk(sys_clk),
		.rst_n(rst_n),
		.dht11_done(dht11_done),
		.tempH(tempH),
		.tempL(tempL),
		.humidityH(humidityH),
		.humidityL(humidityL),
		.ShowData_req(showdata_req),
		.write_done(IIC_Driver6_IICWriteDone),
		.ShowData_Data(OLED_ShowData4_ShowData_Data),
		.ShowData_finish(showdata_finish));

	OLED_SelData OLED_SelData5(
		.sys_clk(sys_clk),
		.rst_n(rst_n),
		.init_req(init_req),
		.init_data(OLED_Init1_Init_data),
		.refresh_req(refresh_req),
		.refresh_data(OLED_Refresh2_refresh_data),
		.showfont_req(showfont_req),
		.showfont_data(OLED_ShowFont3_ShowFont_Data),
		.showdata_req(showdata_req),
		.showdata_data(OLED_ShowData4_ShowData_Data));

	IIC_Driver IIC_Driver6(
		.sys_clk(sys_clk),
		.rst_n(rst_n),
		.IICWriteReq(IICWriteReq),
		.IICSCL(OLED_SCL),
		.IICWriteDone(IIC_Driver6_IICWriteDone),
		.IICSDA(OLED_SDA),
		.IICWriteData(IICWriteData_8),
		.IICSlave(IICWriteData));

	Kalman Kalman7(
		.rst_n(rst_n),
		.clk(sys_clk),
		.data_in(data_in),
		.data_out(data_out));

endmodule    //OLED_T_H_Top

