module Tracking(
	clk,
	rst_n,
	track1,
	track2,
	track3,
	track4,
	dir_l_1,
	dir_l_2,
	dir_r_1,
	dir_r_2,
	f_pwm_l,
	f_pwm_r,
	spd_high_time,
	spd_low_time,
	pwm);

	//---Ports declearation: generated by Robei---
	input clk;
	input rst_n;
	input track1;
	input track2;
	input track3;
	input track4;
	output dir_l_1;
	output dir_l_2;
	output dir_r_1;
	output dir_r_2;
	output f_pwm_l;
	output f_pwm_r;
	input [7:0] spd_high_time;
	input [7:0] spd_low_time;
	output pwm;

	wire clk;
	wire rst_n;
	wire track1;
	wire track2;
	wire track3;
	wire track4;
	reg dir_l_1;
	reg dir_l_2;
	reg dir_r_1;
	reg dir_r_2;
	reg f_pwm_l;
	reg f_pwm_r;
	wire [7:0] spd_high_time;
	wire [7:0] spd_low_time;
	wire pwm;

	//----Code starts here: integrated by Robei-----
	reg	[1:0] flag = 0;
		always@(posedge clk or negedge rst_n)begin
			if(!rst_n)
				flag <= 0;
			else if( !flag)
				flag <= 1;
			else
				flag <= flag;
		end
		
	
		always@(posedge clk)begin
		
			if(flag == 0)begin
				dir_l_1<=0;
				dir_l_2<=0;
				f_pwm_l<=0;
				
				dir_r_1<=0;
				dir_r_2<=0;
				f_pwm_r<=0;
			end 
			
			else if(flag==1)begin
	
				if(track1 == 0 && track2 == 0)begin
					dir_l_1<=0;
					dir_l_2<=1;
					f_pwm_l<=pwm;
					
					dir_r_1<=0;
					dir_r_2<=1;
					f_pwm_r<=pwm;
				end
				
				else if(track1 == 0 && track2 == 1)begin
					dir_l_1<=0;
					dir_l_2<=1;
					f_pwm_l<=pwm;
					
					dir_r_1<=0;
					dir_r_2<=0;
					f_pwm_r<=0;
				end
		
				else if(track1 == 1 && track2 == 0)begin
					dir_l_1<=0;
					dir_l_2<=0;
					f_pwm_l<=0;
				   
				   dir_r_1<=0;
				   dir_r_2<=1;
				   f_pwm_r<=pwm;
				end
	
				else if(track3 == 1 && track4 == 0 && track1 == 1 && track2 == 1)begin
					dir_l_1<=0;
					dir_l_2<=0;
					f_pwm_l<=0;
					
					dir_r_1<=0;
					dir_r_2<=1;
					f_pwm_r<=pwm;
				end
	
				else if(track3 == 0 && track4 == 1 && track1 == 1 && track2 == 1)begin
					dir_l_1<=0;
					dir_l_2<=1;
					f_pwm_l<=pwm;
				   
				   dir_r_1<=0;
				   dir_r_2<=0;
				   f_pwm_r<=0;
				end
			
				else if(track1 == 1 && track2 == 1)begin
					dir_l_1<=0;
					dir_l_2<=0;
					f_pwm_l<=0;
					
					dir_r_1<=0;
					dir_r_2<=0;
					f_pwm_r<=0;
				end
			end 
				
			else;
			
		end
	
	
	
	
	//---Module instantiation---
	pwm_motor pwm_motor1(
		.clk(clk),
		.rst_n(rst_n),
		.spd_high_time(spd_high_time),
		.spd_low_time (spd_low_time),
		.pwm(pwm));

endmodule    //Tracking

