module pwm_motor(
	clk,
	rst_n,
	spd_high_time,
	spd_low_time ,
	period_fini,
	pwm);

	//---Ports declearation: generated by Robei---
	input clk;
	input rst_n;
	input [7:0] spd_high_time;
	input [7:0] spd_low_time ;
	output period_fini;
	output pwm;

	wire clk;
	wire rst_n;
	wire [7:0] spd_high_time;
	wire [7:0] spd_low_time ;
	wire period_fini;
	reg pwm;

	//----Code starts here: integrated by Robei-----
	parameter			idle								= 8'h0,
							step_high 							= 8'h1,
							step_low  							= 8'h2;
							
		reg	[7:0]		curr_st			;
		reg	[7:0]		curr_st_ff1		;
		reg	[10:0]	step_high_time	;
		reg	[10:0]	step_low_time	;
		reg	[10:0]	step_high_cnt	;
		reg	[10:0]	step_low_cnt	;
		
		wire[10:0]	hspd_high_time;
		wire[10:0]	hspd_low_time ;
		
		assign	period_fini=(step_low_cnt==step_low_time)?1'b1:1'b0;
		always@(posedge clk or negedge rst_n)
			begin
				if(!rst_n)
					begin
						step_high_time<=0;
						step_low_time<=0;
					end
				else
					begin
						step_high_time<=spd_high_time;
						step_low_time<=spd_low_time;
					end
			end
		always@(posedge clk)curr_st_ff1<=curr_st	;
		always@(posedge clk or negedge rst_n)
			begin
				if(!rst_n)
					curr_st<=idle;
				else case(curr_st)
					idle:curr_st<=step_high	;
					step_high:
						begin
							if(step_high_cnt==step_high_time)
								curr_st<=step_low;
							else
								;
						end
					step_low:
						begin
							if(step_low_cnt==step_low_time)
								curr_st<=step_high;
							else
								;
						end
					default:;
				endcase
			end
		always@(posedge clk or negedge rst_n)
			begin
				if(!rst_n)
					step_high_cnt<=0;
				else if(curr_st==idle)
					step_high_cnt<=0;
				else if(curr_st==step_high)
					step_high_cnt<=step_high_cnt+1;
				else
					step_high_cnt<=0;
			end
		always@(posedge clk or negedge rst_n)
			begin
				if(!rst_n)
					step_low_cnt<=0;
				else if(curr_st==idle)
					step_low_cnt<=0;
				else if(curr_st==step_low)
					step_low_cnt<=step_low_cnt+1;
				else
					step_low_cnt<=0;
			end
		always@(posedge clk or negedge rst_n)
			begin
				if(!rst_n)
					begin
						pwm<=0;
					end
				else if(curr_st==idle)
					begin
						pwm<=0;
					end
				else if(curr_st==step_high)
					pwm<=1;
				else if(curr_st==step_low)
					pwm<=0;
				else
					pwm<=1;
			end
	
	
	
	
endmodule    //pwm_motor

