module Line_Shift_RAM_1Bit(
	clock,
	clken,
	shiftin,
	taps0x,
	taps1x,
	taps2x);

	//---Ports declearation: generated by Robei---
	input clock;
	input clken;
	input shiftin;
	output taps0x;
	output taps1x;
	output taps2x;

	wire clock;
	wire clken;
	wire shiftin;
	wire taps0x;
	wire taps1x;
	wire taps2x;
	wire fifo_ram_11_rd_data;
	assign taps1x = fifo_ram_11_rd_data;

	//----Code starts here: integrated by Robei-----
	wire    [1 - 1 :   0]      fifo_rd_data0;
	reg     [1 - 1 :   0]      fifo_rd_data0_d1;
	wire    [1 - 1 :   0]      fifo_rd_data1;
	reg                                 clken_d1;
	reg                                 clken_d2;
	reg     [1 - 1 :   0]      shiftin_d1; 
	reg     [1 - 1 :   0]      shiftin_d2; 
	
	always@(posedge clock)begin
	    clken_d1            <=  clken;
	    clken_d2            <=  clken_d1;
	    shiftin_d1          <=  shiftin;
	    shiftin_d2          <=  shiftin_d1;
	    fifo_rd_data0_d1    <=  fifo_rd_data0;
	end
	
	fifo_ram_1 u_fifo_ram0(
	    .clk        (clock),   
	    //write port
	    .wr_en      (clken_d2),
	    .wr_data    (shiftin_d2),
	   //read port
	    .rd_en      (clken),
	    .rd_data    (fifo_rd_data0) 
	
	);
	
	fifo_ram_1 u_fifo_ram1(
	    .clk        (clock),   
	    //write port
	    .wr_en      (clken_d2),
	    .wr_data    (fifo_rd_data0_d1),
	
	    //read port
	    .rd_en      (clken),
	    .rd_data    (fifo_rd_data1)
	 
	);
	
	assign  taps0x  =   shiftin_d1;
	assign  taps1x  =   fifo_rd_data0;
	assign  taps2x  =   fifo_rd_data1;
	
	
	
	
	//---Module instantiation---
	fifo_ram_1 fifo_ram_11(
		.clk(clock),
		.wr_en(clken),
		.wr_data(shiftin),
		.rd_en(clken),
		.rd_data(fifo_ram_11_rd_data));

	fifo_ram_1 fifo_ram_12(
		.clk(clock),
		.wr_en(clken),
		.wr_data(fifo_ram_11_rd_data),
		.rd_en(clken),
		.rd_data(taps2x));

endmodule    //Line_Shift_RAM_1Bit

