module VIP_Matrix_Generate_3X3_1Bit(
	clk,
	rst_n,
	per_frame_vsync,
	per_frame_href,
	per_frame_clken,
	matrix_frame_vsync,
	matrix_frame_href,
	matrix_frame_clken,
	matrix_p11,
	matrix_p12,
	matrix_p13,
	matrix_p21,
	matrix_p22,
	matrix_p23,
	matrix_p31,
	matrix_p32,
	matrix_p33,
	per_img_Bit);

	//---Ports declearation: generated by Robei---
	input clk;
	input rst_n;
	input per_frame_vsync;
	input per_frame_href;
	input per_frame_clken;
	output matrix_frame_vsync;
	output matrix_frame_href;
	output matrix_frame_clken;
	output matrix_p11;
	output matrix_p12;
	output matrix_p13;
	output matrix_p21;
	output matrix_p22;
	output matrix_p23;
	output matrix_p31;
	output matrix_p32;
	output matrix_p33;
	input per_img_Bit;

	wire clk;
	wire rst_n;
	wire per_frame_vsync;
	wire per_frame_href;
	wire per_frame_clken;
	wire matrix_frame_vsync;
	wire matrix_frame_href;
	wire matrix_frame_clken;
	reg matrix_p11;
	reg matrix_p12;
	reg matrix_p13;
	reg matrix_p21;
	reg matrix_p22;
	reg matrix_p23;
	reg matrix_p31;
	reg matrix_p32;
	reg matrix_p33;
	wire per_img_Bit;

	//----Code starts here: integrated by Robei-----
	wire	row1_data;
	wire	row2_data;	
	reg		row3_data;	
	always@(posedge clk or negedge rst_n)
	begin
		if(!rst_n)
			row3_data <= 0;
		else 
			begin
			if(per_frame_clken)
				row3_data <= per_img_Bit;
			else
				row3_data <= row3_data;
			end
	end
	
	
	wire	shift_clk_en = per_frame_clken;
	
	Line_Shift_RAM_1Bit  u_Line_Shift_RAM_1Bit
	(
		.clock		(clk),
		.clken		(shift_clk_en),	
	//	.aclr		(1'b0),
	
		.shiftin	(row3_data),	
		.taps1x		(row2_data),
		.taps2x		(row1_data)
		//.shiftout	()
	);
	
	 
	reg	[1:0]	per_frame_vsync_r;
	reg	[1:0]	per_frame_href_r;	
	reg	[1:0]	per_frame_clken_r;
	always@(posedge clk or negedge rst_n)
	begin
		if(!rst_n)
			begin
			per_frame_vsync_r <= 0;
			per_frame_href_r <= 0;
			per_frame_clken_r <= 0;
			end
		else
			begin
			per_frame_vsync_r 	<= 	{per_frame_vsync_r[0], 	per_frame_vsync};
			per_frame_href_r 	<= 	{per_frame_href_r[0], 	per_frame_href};
			per_frame_clken_r 	<= 	{per_frame_clken_r[0], 	per_frame_clken};
			end
	end
	
	wire	read_frame_href		=	per_frame_href_r[0];	
	wire	read_frame_clken	=	per_frame_clken_r[0];	
	assign	matrix_frame_vsync 	= 	per_frame_vsync_r[1];
	assign	matrix_frame_href 	= 	per_frame_href_r[1];
	assign	matrix_frame_clken 	= 	per_frame_clken_r[1];
	
	
	
	always@(posedge clk or negedge rst_n)
	begin
		if(!rst_n)
			begin
			{matrix_p11, matrix_p12, matrix_p13} <= 3'b0;
			{matrix_p21, matrix_p22, matrix_p23} <= 3'b0;
			{matrix_p31, matrix_p32, matrix_p33} <= 3'b0;
			end
		else if(read_frame_href)
			begin
			if(read_frame_clken)	
				begin
				{matrix_p11, matrix_p12, matrix_p13} <= {matrix_p12, matrix_p13, row1_data};	
				{matrix_p21, matrix_p22, matrix_p23} <= {matrix_p22, matrix_p23, row2_data};	
				{matrix_p31, matrix_p32, matrix_p33} <= {matrix_p32, matrix_p33, row3_data};
				end
			else
				begin
				{matrix_p11, matrix_p12, matrix_p13} <= {matrix_p11, matrix_p12, matrix_p13};
				{matrix_p21, matrix_p22, matrix_p23} <= {matrix_p21, matrix_p22, matrix_p23};
				{matrix_p31, matrix_p32, matrix_p33} <= {matrix_p31, matrix_p32, matrix_p33};
				end	
			end
		else
			begin
			{matrix_p11, matrix_p12, matrix_p13} <= 3'b0;
			{matrix_p21, matrix_p22, matrix_p23} <= 3'b0;
			{matrix_p31, matrix_p32, matrix_p33} <= 3'b0;
			end
	end
	
	
	
	//---Module instantiation---
	Line_Shift_RAM_1Bit Line_Shift_RAM_1Bit1(
		.clock(clk),
		.clken(per_frame_clken),
		.shiftin(per_img_Bit));

endmodule    //VIP_Matrix_Generate_3X3_1Bit

