module fifo_ram_1(
	clk,
	wr_en,
	wr_data,
	rd_en,
	rd_data);

	//---Ports declearation: generated by Robei---
	input clk;
	input wr_en;
	input wr_data;
	input rd_en;
	output rd_data;

	wire clk;
	wire wr_en;
	wire wr_data;
	wire rd_en;
	reg rd_data;

	//----Code starts here: integrated by Robei-----
	reg [1 - 1 : 0] fifo_buffer[1024 - 1 : 0];
	 integer i;
	
	    initial begin
	        for(i = 0;i<1024;i = i + 1)begin
	            fifo_buffer[i] <=  0;
	        end
	    end
	
	    reg     [/*$clog2(DATA_DEPTH)*/10 - 1 : 0]    wr_pointer = 0;
	    reg     [/*$clog2(DATA_DEPTH)*/10 - 1 : 0]    rd_pointer = 0;
	    wire    [1 - 1 : 0]            rd_data_out;
	
	
	always @(posedge clk) begin
	    if (wr_en) begin
	        if (wr_pointer == 1024 - 1) begin
	            wr_pointer <= 0; 
	        end
	        else begin
	            wr_pointer <= wr_pointer + 1;
	        end
	    end
	end
	
	
	always @(posedge clk) begin
	    if (rd_en) begin
	        if (rd_pointer == 1024 - 1) begin
	            rd_pointer <= 0;
	        end
	        else begin
	            rd_pointer <= rd_pointer + 1;
	        end
	    end
	end
	
	
	always @(posedge clk) begin
	    if (wr_en) begin
	        fifo_buffer[wr_pointer] <= wr_data;
	    end
	end
	
	assign rd_data_out = rd_en ? fifo_buffer[rd_pointer] : 0;
	    
	always @(posedge clk) begin
	    rd_data <=  rd_data_out;
	end
	
	
	
	
endmodule    //fifo_ram_1

