module fushi(
	clk,
	rst_n,
	per_frame_vsync,
	per_frame_href,
	per_frame_clken,
	per_img_Bit,
	post_frame_vsync,
	post_frame_href,
	post_frame_clken,
	post_img_Bit);

	//---Ports declearation: generated by Robei---
	input clk;
	input rst_n;
	input per_frame_vsync;
	input per_frame_href;
	input per_frame_clken;
	input per_img_Bit;
	output post_frame_vsync;
	output post_frame_href;
	output post_frame_clken;
	output post_img_Bit;

	wire clk;
	wire rst_n;
	wire per_frame_vsync;
	wire per_frame_href;
	wire per_frame_clken;
	wire per_img_Bit;
	wire post_frame_vsync;
	wire post_frame_href;
	wire post_frame_clken;
	wire post_img_Bit;

	//----Code starts here: integrated by Robei-----
	wire			matrix_frame_vsync;	
	wire			matrix_frame_href;	
	wire			matrix_frame_clken;		
	wire			matrix_p11, matrix_p12, matrix_p13;	
	wire			matrix_p21, matrix_p22, matrix_p23;
	wire			matrix_p31, matrix_p32, matrix_p33;
	VIP_Matrix_Generate_3X3_1Bit	 u_VIP_Matrix_Generate_3X3_1Bit
	(
		
		.clk					(clk),  				
		.rst_n					(rst_n),				
	
		//Image data prepred to be processd
		.per_frame_vsync		(per_frame_vsync),	
		.per_frame_href			(per_frame_href),	
		.per_frame_clken		(per_frame_clken),	
		.per_img_Bit			(per_img_Bit),		
		//Image data has been processd
		.matrix_frame_vsync		(matrix_frame_vsync),	
		.matrix_frame_href		(matrix_frame_href),
		.matrix_frame_clken		(matrix_frame_clken),	
		.matrix_p11(matrix_p11),	.matrix_p12(matrix_p12), 	.matrix_p13(matrix_p13),	
		.matrix_p21(matrix_p21), 	.matrix_p22(matrix_p22), 	.matrix_p23(matrix_p23),
		.matrix_p31(matrix_p31), 	.matrix_p32(matrix_p32), 	.matrix_p33(matrix_p33)
	);
	
	
	
	reg	post_img_Bit1,	post_img_Bit2,	post_img_Bit3;
	always@(posedge clk or negedge rst_n)
	begin
		if(!rst_n)
			begin
			post_img_Bit1 <= 1'b0;
			post_img_Bit2 <= 1'b0;
			post_img_Bit3 <= 1'b0;
			end
		else
			begin
			post_img_Bit1 <= matrix_p11 & matrix_p12 & matrix_p13;
			post_img_Bit2 <= matrix_p21 & matrix_p22 & matrix_p23;
			post_img_Bit3 <= matrix_p21 & matrix_p32 & matrix_p33;
			end
	end
	
	//Step 2
	reg	post_img_Bit4;
	always@(posedge clk or negedge rst_n)
	begin
		if(!rst_n)
			post_img_Bit4 <= 1'b0;
		else
			post_img_Bit4 <= post_img_Bit1 & post_img_Bit2 & post_img_Bit3;
	end
	
	
	reg	[1:0]	per_frame_vsync_r;
	reg	[1:0]	per_frame_href_r;	
	reg	[1:0]	per_frame_clken_r;
	always@(posedge clk or negedge rst_n)
	begin
		if(!rst_n)
			begin
			per_frame_vsync_r <= 0;
			per_frame_href_r <= 0;
			per_frame_clken_r <= 0;
			end
		else
			begin
			per_frame_vsync_r 	<= 	{per_frame_vsync_r[0], 	matrix_frame_vsync};
			per_frame_href_r 	<= 	{per_frame_href_r[0], 	matrix_frame_href};
			per_frame_clken_r 	<= 	{per_frame_clken_r[0], 	matrix_frame_clken};
			end
	end
	assign	post_frame_vsync 	= 	per_frame_vsync_r[1];
	assign	post_frame_href 	= 	per_frame_href_r[1];
	assign	post_frame_clken 	= 	per_frame_clken_r[1];
	assign	post_img_Bit		=	post_frame_href ? post_img_Bit4 : 1'b0;
	
	
	
	
	//---Module instantiation---
	VIP_Matrix_Generate_3X3_1Bit VIP_Matrix_Generate_3X3_1Bit1(
		.clk(clk),
		.rst_n(rst_n),
		.per_frame_vsync(per_frame_vsync),
		.per_frame_href(per_frame_href),
		.per_frame_clken(per_frame_clken),
		.per_img_Bit(per_img_Bit));

endmodule    //fushi

